//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "zlib/zlib.h"
#include "UpDownClient.h"
#include "opcodes.h"
#include "packets.h"
#include "emule.h"
#include "uploadqueue.h"
#include "otherstructs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//	members of CUpDownClient
//	which are mainly used for uploading functions 

CBarShader CUpDownClient::s_UpStatusBar(16);

void CUpDownClient::DrawUpStatusBar(CDC* dc, RECT* rect, bool onlygreyrect, bool  bFlat){ 
	EMULE_TRY

	COLORREF crBoth; 
	COLORREF crNeither; 
/*	COLORREF crClientOnly; 
	COLORREF crPending = RGB(255,208,0);
	COLORREF crNextPending = RGB(255,255,100);
	//--- xrmb:seetheneed ---
	COLORREF crMeOnly = RGB(190,190,255); 
	//--- :xrmb ---
*/
	if(bFlat) { 
		crBoth = RGB(0, 150, 0);
		crNeither = RGB(224, 224, 224);
		//crClientOnly = RGB(0, 0, 0);
	} else { 
		crBoth = RGB(0, 192, 0);	//Cax2 - same green used for files & clients
		crNeither = RGB(240, 240, 240);
		//crClientOnly = RGB(95, 95, 95);
	} 


    uint32 filesize = PARTSIZE*(m_nUpPartCount); // might be a little off.. better than nothing

	s_UpStatusBar.SetFileSize(filesize); 
	s_UpStatusBar.SetHeight(rect->bottom - rect->top); 
	s_UpStatusBar.SetWidth(rect->right - rect->left); 
	s_UpStatusBar.Fill(crNeither); 

	if (!onlygreyrect && m_abyUpPartStatus) { 
		for (uint32 i = 0;i != m_nUpPartCount;i++)
		{ 
		        uint32 uEnd = filesize;
            /* no need for that now, cause we don't use the precise filesize
			//--- xrmb:seetheneed --- & Cax2 graphic glitch fix
			if (PARTSIZE*(i+1) > filesize) 
				uEnd = filesize; 
			else 
				uEnd = PARTSIZE*(i+1); 
            */
			
			if (m_abyUpPartStatus[i]){ //they have this part
                /*
				// do i have it ?
				if  (reqfile->IsComplete(PARTSIZE*i,PARTSIZE*(i+1)-1))
					s_StatusBar.FillRange(PARTSIZE*i,  uEnd, crBoth); 
				else if (m_nDownloadState == DS_DOWNLOADING && m_nLastBlockOffset < uEnd && 
                                                     m_nLastBlockOffset >= PARTSIZE*i)
						s_StatusBar.FillRange(PARTSIZE*i, uEnd, crPending);
				else if (gettingParts.GetAt(i) == 'Y')
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crNextPending);
	    		else
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crClientOnly);
                */
                s_UpStatusBar.FillRange(PARTSIZE*i, uEnd, crBoth); // will do for now
			}
			else //they don't have a part. Do I have it?
                /*
				if (reqfile->IsComplete(PARTSIZE*i,PARTSIZE*(i+1)-1)) 
					s_StatusBar.FillRange(PARTSIZE*i,  uEnd, crMeOnly); 
                */
                s_UpStatusBar.FillRange(PARTSIZE*i, uEnd, crNeither);
		} 
   	} 
   	s_UpStatusBar.Draw(dc, rect->left, rect->top, bFlat); 

	EMULE_CATCH
} 

// [i_a] 
bool CUpDownClient::IsCommunity()                
{    
	EMULE_TRY
    if (!community_cached) 
    { 
        // [i_a] DonGato (Community Sharing)  
        CString copy1(GetUserName()); 
        CString copy2(theApp.glob_prefs->CommunityString()); 
        copy1.MakeUpper(); 
        copy2.MakeUpper(); 
        iscommunity = (copy1.Find(copy2) >= 0); 
        community_cached = true; 
    } 
    return iscommunity; 
	EMULE_CATCH
	return false;
} 

void CUpDownClient::ResetValueCache() 
{ 
	EMULE_TRY
    score_base_cached = false; 
    community_cached = false; 
	EMULE_CATCH
} 
// [/i_a] 

uint32 CUpDownClient::GetScore(bool sysvalue, bool isdownloading, bool onlybasevalue){
	EMULE_TRY
	//TODO: complete this (friends, uploadspeed, emuleuser etc etc)
	if (!m_pszUsername)
		return 0;
	if (sysvalue && HasLowID() && !(socket && socket->IsConnected())){
		return 0;
	}
	if (!score_base_cached) 
	{ 

	//Cax2: removed bot user & low id 'punishments' . 
	// Bot user?
	//m_bIsBotuser = (strstr(m_pszUsername, "edk-files") || strstr(m_pszUsername, "finder")) && strstr(m_pszUsername, "com");

	// DonGato (Community Sharing)
	// Maverick only 1 community possible
	char *copy1, *copy2;
	copy1 = _strupr( _strdup( m_pszUsername ) );
	copy2 = _strupr( _strdup( "[" + theApp.glob_prefs->CommunityString() + "]") );
	bool iscommunity = (strstr(copy1 ,copy2) != NULL );
	if (iscommunity) 
		iscommunity = ((strchr(copy1,'[') == strrchr(copy1,'[')) || (strchr(copy1,']') == strrchr(copy1,']')));
	free(copy1);
	free(copy2);

	// TODO coded by tecxx & herbert, one yet unsolved problem here:
	// sometimes a client asks for 2 files and there is no way to decide, which file the 
	// client finally gets. so it could happen that he is queued first because of a 
	// high prio file, but then asks for something completely different.
	
	// isfriend = 	theApp.emuledlg->chatwnd.IsFriend(CString(m_pszUsername));
	// isemuleclient = false; // i_a: unused
	filepriority = 10; // standard	
        ASSERT(reqfileid != NULL); // i_a: reqfileid is an array so the if() was superfluous 
         { 
		if(theApp.sharedfiles->GetFileByID(reqfileid) != NULL){ 
			switch(theApp.sharedfiles->GetFileByID(reqfileid)->GetPriority()){ 
				case PR_VERYHIGH: // Modified by Tarod for UAP
					if (theApp.sharedfiles->GetFileByID(reqfileid)->IsPartFile()) {
						filepriority = 50;
					} else {
						filepriority = 100;
					}
					break;
				case PR_HIGH: 
					filepriority = 20; 
					break; 
				case PR_LOW: 
					filepriority = 5; 
					break; 
				case PR_VERYLOW:
					filepriority = 2;
					break;
				case PR_NORMAL: 
					default: 
					filepriority = 10; 
				break; 
			} 
		} 
	} 
        score_base_cached = true; // i_a 
      } 
	// friend slot
	if (IsFriend() && GetFriendSlot())
		return 0xFFFFFFFF;
	// calculate score, based on waitingtime and other factors
	float fBaseValue;
	if (onlybasevalue)
		fBaseValue = 100.0f;
	else if (!isdownloading)
		fBaseValue = (float)(GetTickCount()-m_dwWaitTime)/1000.0f;
	else{
		// we dont want one client to download forever
		// the first 15 min downloadtime counts as 15 min waitingtime and you get a 15 min bonus while you are in the first 15 min :)
		// (to avoid 20 sec downloads) after this the score won't raise anymore 
		fBaseValue = (float)(m_dwUploadTime-m_dwWaitTime);
		ASSERT ( m_dwUploadTime-m_dwWaitTime >= 0 ); //oct 28, 02: changed this from "> 0" to ">= 0"
		fBaseValue += (float)(GetTickCount() - m_dwUploadTime > 900000)? 900000.0f:1800000.0f;
		fBaseValue /= 1000.0f;
	}	
	if (GetDownloadState() == DS_DOWNLOADING && GetDatarate() > 500) // obaldin: prevent 0.1 upload abuse
		fBaseValue *= 1.5f; // since up/down credits are in, this isn't that improtant anymore
	if (IsFriend())
		fBaseValue *= 2.0f;
	// DonGato (Community Sharing)
	if (theApp.glob_prefs->CommunityEnabled())
	{
		if (iscommunity)
			fBaseValue *= 2.0f;
	}
	//
	
	//Fix by Amdribant [loadedsrc]
	//ASSERT(credits != NULL); 
	if(credits != (CClientCredits*)NULL) { 
		fBaseValue *= credits->GetScoreRatio();
	} 

	// Added by Tarod (herbert code)
	fBaseValue *= GetSmallFilePushRatio() ;
	fBaseValue *= GetRareFilePushRatio() ;
	// End by Tarod

	/*if (!onlybasevalue)*/
		fBaseValue *= ((float)(filepriority))/10.0f; 
	if (IsBanned())
		return 0;

	if (!isdownloading && !onlybasevalue){
		if (HasLowID() && !(socket && socket->IsConnected()) ){
			if (!theApp.serverconnect->IsConnected() || theApp.serverconnect->IsLowID() || theApp.listensocket->TooManySockets())
				return 0;
		}
	}
	return (uint32)fBaseValue;

	EMULE_CATCH
	return 1;
}

// Added by Tarod based in herbert code and modifications by MatzeHH
float CUpDownClient::GetRareFilePushRatio(){
	EMULE_TRY
	//if(!theApp.glob_prefs->FairShareRarePush())
	//	return 1.0f;
	CKnownFile* srcfile = theApp.sharedfiles->GetFileByID((uchar*)reqfileid);
	if (srcfile == NULL)
		return 1.0f;
	
	// keep the FileRatio
	float ratio = 0+srcfile->GetFileRatio() ;
	return (ratio < 1.0f ? 1.0f :((ratio>100.0f)?100.0f: ratio)) ;		//Cax2 bugfix

	EMULE_CATCH
	return 1.0f;
}

// Checks if it is next requested block from another chunk of the actual file or from another file 
// 
// [Returns] 
//   true : Next requested block is from another different chunk or file than last downloaded block 
//   false: Next requested block is from same chunk that last downloaded block 
bool CUpDownClient::IsDifferentPartBlock(void) // [Tarod 12/22/2002] 
{ 
	Requested_Block_Struct* last_done_block;
	Requested_Block_Struct* next_requested_block;
	uint32 last_done_part = 0xffffffff;
	uint32 next_requested_part = 0xffffffff;
	
	bool different_part = false;
	
    // obaldin: this is for old clients, that rotate the chunk,
    // so that they'll be able to download at least _something_
    // But probably even after the majority switches we'd
    // better check for 0 here
    if(this->GetTransferedUp() < 1024*1024) {
        return false;
    }
	
	try {
		// Check if we have good lists and proceed to check for different chunks
		if (!m_BlockRequests_queue.IsEmpty() && !m_DoneBlocks_list.IsEmpty())
		{
			// Get last block and next pending
			last_done_block = (Requested_Block_Struct*)m_DoneBlocks_list.GetHead();
			next_requested_block = (Requested_Block_Struct*)m_BlockRequests_queue.GetHead(); 
			
			// Calculate corresponding parts to blocks
			last_done_part = last_done_block->StartOffset / PARTSIZE;
			next_requested_part = next_requested_block->StartOffset / PARTSIZE; 
             
			// Test is we are asking same file and same part
			if ( last_done_part != next_requested_part)
			{ 
				different_part = true;
				theApp.emuledlg->AddDebugLogLine(false, "Session ended due to new chunk.");
			}
			if (memcmp(last_done_block->FileID, next_requested_block->FileID, 16) != 0)
			{ 
				different_part = true;
				theApp.emuledlg->AddDebugLogLine(false, "Session ended due to different file.");
			}
		} 
   	}
   	catch(...)
   	{ 
      		different_part = true; 
   	} 
	//theApp.emuledlg->AddDebugLogLine(false, "User %s, last_done_part (%u) %s (%u) next_requested_part, sent %u Kbs.", GetUserName(), last_done_part, different_part? "!=": "==", next_requested_part, this->GetTransferedUp() / 1024); 
	// obaldin: this message was causing a high cpu load for users, so we comment it out.
	// NB: When (if) we have time, see why the catch(...) is used here

	return different_part; 
}


float CUpDownClient::GetSmallFilePushRatio(){
	EMULE_TRY
	//if(!theApp.glob_prefs->FairShareRarePush())
	//	return 1.0f;
	CKnownFile* srcfile = theApp.sharedfiles->GetFileByID((uchar*)reqfileid);
	if (srcfile == NULL)
		return 1.0f;

	//Cax2 faster code ....
	long filesize = srcfile->GetFileSize() ;

	//if (filesizeinmb > 0.0f && filesizeinmb < 9.5f) {
	if (filesize > 0.0f && filesize < 9961472) {

		// Modded by Tarod to: Min(100, Max(1, 9.5 / FS)) [9.5 Mbs. == Chunk Size]
		float mul = 9961472/ filesize ;		// VQB formula + Cax2 overflow bugfix...
		if (mul > 100.0f) mul = 100.0f ;		// VQB formula 
		return mul ;
	}

	EMULE_CATCH
	return 1.0f;
}
// End added by Tarod


bool CUpDownClient::CreateNextBlockPackage(){
	// time critical
	// check if we should kick this client
	// DonGato [By VQB]
	if (theApp.glob_prefs->TransferFullChunks())
	{
	// VQB to provide full chunk transfers (modified by Tarod)
	if ( theApp.uploadqueue->CheckForTimeOver(this) || IsDifferentPartBlock())
	{
		SetWaitStartTime();
		SetAskedCount(0);
		theApp.uploadqueue->RemoveFromUploadQueue(this);
		theApp.uploadqueue->AddClientToQueue(this,true);
		return false;
	}
	} else {
		if (theApp.uploadqueue->CheckForTimeOver(this))
		{
			// back on the waitqueue
			SetWaitStartTime();
			theApp.uploadqueue->RemoveFromUploadQueue(this);
			theApp.uploadqueue->AddClientToQueue(this,true);
			return false;
		}
	}
	if (m_BlockRequests_queue.IsEmpty()){
		return false;
	}
	CFile file;
	byte* filedata = 0;
	char* fullname = 0;
	try{
		while (!m_BlockRequests_queue.IsEmpty()){
			Requested_Block_Struct* currentblock = m_BlockRequests_queue.GetHead();
			CKnownFile* srcfile = theApp.sharedfiles->GetFileByID(currentblock->FileID);
			if (!srcfile)
				throw GetResString(IDS_ERR_REQ_FNF);

			if (srcfile->IsPartFile() && ((CPartFile*)srcfile)->GetStatus() != PS_COMPLETE){
				fullname = nstrdup(((CPartFile*)srcfile)->GetFullName());
				fullname[strlen(fullname)-4] = 0;			
			}
			else{
				fullname = new char[strlen(srcfile->GetPath())+strlen(srcfile->GetFileName())+10];
				sprintf(fullname,"%s\\%s",srcfile->GetPath(),srcfile->GetFileName());
			}
		
			uint32 togo;
			if (currentblock->StartOffset > currentblock->EndOffset){
				togo = currentblock->EndOffset + (srcfile->GetFileSize() - currentblock->StartOffset);
			}
			else{
				togo = currentblock->EndOffset - currentblock->StartOffset;
				if (srcfile->IsPartFile() && !((CPartFile*)srcfile)->IsComplete(currentblock->StartOffset,currentblock->EndOffset-1))
					throw GetResString(IDS_ERR_INCOMPLETEBLOCK);
			}
			
			if( togo > 184320 )
				throw "GetResString(IDS_ERR_LARGEREQBLOCK)";
			
			if (!srcfile->IsPartFile()){
				if (!file.Open(fullname,CFile::modeRead|CFile::osSequentialScan|CFile::shareDenyNone))
					throw GetResString(IDS_ERR_OPEN);
				delete[] fullname;
				fullname = 0;
				file.Seek(currentblock->StartOffset,0);
				
				filedata = new byte[togo+500];
				if (uint32 done = file.Read(filedata,togo) != togo){
					file.SeekToBegin();
					file.Read(filedata + done,togo-done);
				}
				file.Close();
			}
			else{
				CPartFile* partfile = (CPartFile*)srcfile;
				delete[] fullname;
				fullname = 0;
				partfile->m_hpartfile.Seek(currentblock->StartOffset,0);
				
				filedata = new byte[togo+500];
				if (uint32 done = partfile->m_hpartfile.Read(filedata,togo) != togo){
					partfile->m_hpartfile.SeekToBegin();
					partfile->m_hpartfile.Read(filedata + done,togo-done);
				}
			}

			memcpy(reqfileid,currentblock->FileID,16);
			if (m_byDataCompVer == 1 && (!strstr(srcfile->GetFileName(),".zip")) && (!strstr(srcfile->GetFileName(),".rar")) && (!strstr(srcfile->GetFileName(),".ace")))
				CreatePackedPackets(filedata,togo,currentblock);
			else
				CreateStandartPackets(filedata,togo,currentblock);
			
			// file statistic
			srcfile->statistic.AddTransferd(togo);

			//--- xrmb:parttraffic ---
			srcfile->statistic.AddTraffic(currentblock->StartOffset, togo);
			//--- :xrmb ---

			m_DoneBlocks_list.AddHead(m_BlockRequests_queue.RemoveHead());
			delete[] filedata;
			filedata = 0;
		}
	}
	catch(CString &error){
		OUTPUT_DEBUG_TRACE();
		theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_ERR_CLIENTERRORED),GetUserName(),error.GetBuffer());
		theApp.uploadqueue->RemoveFromUploadQueue(this);
		if (filedata)
			delete filedata;
		if (fullname)
			delete[] fullname;
		return false;
	}
//	theApp.emuledlg->AddDebugLogLine(false,"Debug: Packet done. Size: %i",blockpack->GetLength());
	return true;
}

void CUpDownClient::CheckForUpPartsInfo(){
    if(m_nPartCount==0)
        return;
    if(!reqfile)
        return;
    if(memcmp(reqfileid,reqfile->GetFileHash(),16))
        return;
    if(!m_abyPartStatus)
        return;

    if (m_abyUpPartStatus) {
		delete[] m_abyUpPartStatus;
		m_abyUpPartStatus = NULL;
    }
	m_nUpPartCount = m_nPartCount;
    m_nAvailUpPartCount = 0;
    m_abyUpPartStatus = new uint8[m_nUpPartCount];
    for(int i=0; i<m_nUpPartCount; i++) {
        m_abyUpPartStatus[i] = m_abyPartStatus[i];
        if(m_abyUpPartStatus[i]) 
            m_nAvailUpPartCount++;
    }
}

void CUpDownClient::ProcessUpFileStatus(char* packet,uint32 size){
    EMULE_TRY

    if (m_abyUpPartStatus) {
		delete[] m_abyUpPartStatus;
		m_abyUpPartStatus = NULL;	// added by jicxicmic
    }
	m_nUpPartCount = 0;
    m_nAvailUpPartCount = 0;
    if( size == 16 ) {
        CheckForUpPartsInfo(); // obaldin
		return;
    }
	CSafeMemFile* data = new CSafeMemFile((BYTE*)packet,size);
	uchar cfilehash[16];
	data->Read(cfilehash,16);
	CKnownFile* tempreqfile = theApp.sharedfiles->GetFileByID(cfilehash);
	data->Read(&m_nUpPartCount,2);
	if (!m_nUpPartCount){
		m_nUpPartCount = tempreqfile->GetPartCount();
		m_abyUpPartStatus = new uint8[m_nUpPartCount];
		memset(m_abyUpPartStatus,0,m_nUpPartCount);
	}
	else{
		if (tempreqfile->GetPartCount() != m_nUpPartCount){
			delete data;	//mf
			m_nUpPartCount = 0;
			return;
		}
		m_abyUpPartStatus = new uint8[m_nUpPartCount];
		uint16 done = 0;
		while (done != m_nUpPartCount){
			uint8 toread;
			data->Read(&toread,1);
			for (sint32 i = 0;i != 8;i++){
				m_abyUpPartStatus[done] = ((toread>>i)&1)? 1:0;
                if(m_abyUpPartStatus[done])
                    m_nAvailUpPartCount++;
//				We may want to use this for another feature..
//				if (m_abyUpPartStatus[done] && !tempreqfile->IsComplete(done*PARTSIZE,((done+1)*PARTSIZE)-1))
//					bPartsNeeded = true;
				done++;
				if (done == m_nUpPartCount)
					break;
			}
		}

	}
	theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(this);
	delete data;

    EMULE_CATCH
}


void CUpDownClient::CreateStandartPackets(byte* data,uint32 togo, Requested_Block_Struct* currentblock){
	EMULE_TRY
	uint32 nPacketSize;
	CMemFile memfile((BYTE*)data,togo);
	if (togo > 10240) 
		nPacketSize = togo/(uint32)(togo/10240);
	else
		nPacketSize = togo;
	while (togo){
		if (togo < nPacketSize*2)
			nPacketSize = togo;
		togo -= nPacketSize;
		Packet* packet = new Packet(OP_SENDINGPART,nPacketSize+24);
		memcpy(&packet->pBuffer[0],reqfileid,16);
		uint32 statpos = (currentblock->EndOffset - togo) - nPacketSize;
		memcpy(&packet->pBuffer[16],&statpos,4);
		uint32 endpos = (currentblock->EndOffset - togo);
		memcpy(&packet->pBuffer[20],&endpos,4);
		memfile.Read(&packet->pBuffer[24],nPacketSize);
		m_BlockSend_queue.AddTail(packet);
	}
	EMULE_CATCH
}

void CUpDownClient::CreatePackedPackets(byte* data,uint32 togo, Requested_Block_Struct* currentblock){
	EMULE_TRY
	BYTE* output = new BYTE[togo+300];
	uLongf newsize = togo+300;
	uint16 result = compress2(output,&newsize,data,togo,9);
	if (result != Z_OK || togo <= newsize){
		delete[] output;
		CreateStandartPackets(data,togo,currentblock);
		return;
	}
	m_bUsedComprUp = true;
	compressiongain += (togo-newsize); // Add show compression
	notcompressed += togo;// Add show compression
	CMemFile memfile(output,newsize);
	togo = newsize;
	uint32 nPacketSize;
	if (togo > 10240) 
		nPacketSize = togo/(uint32)(togo/10240);
	else
		nPacketSize = togo;
	while (togo){
		if (togo < nPacketSize*2)
			nPacketSize = togo;
		togo -= nPacketSize;
		Packet* packet = new Packet(OP_COMPRESSEDPART,nPacketSize+24,OP_EMULEPROT);
		memcpy(&packet->pBuffer[0],reqfileid,16);
		uint32 statpos = currentblock->StartOffset;
		memcpy(&packet->pBuffer[16],&statpos,4);
		memcpy(&packet->pBuffer[20],&newsize,4);
		memfile.Read(&packet->pBuffer[24],nPacketSize);
		m_BlockSend_queue.AddTail(packet);
	}
	delete[] output;
	EMULE_CATCH
}


void CUpDownClient::AddReqBlock(Requested_Block_Struct* reqblock){
	EMULE_TRY
	for (POSITION pos = m_DoneBlocks_list.GetHeadPosition();pos != 0;m_DoneBlocks_list.GetNext(pos)){
		if (reqblock->StartOffset == m_DoneBlocks_list.GetAt(pos)->StartOffset && reqblock->EndOffset == m_DoneBlocks_list.GetAt(pos)->EndOffset){
			delete reqblock;
			return;
		}
	}
	for (POSITION pos = m_BlockRequests_queue.GetHeadPosition();pos != 0;m_BlockRequests_queue.GetNext(pos)){
		if (reqblock->StartOffset == m_BlockRequests_queue.GetAt(pos)->StartOffset && reqblock->EndOffset == m_BlockRequests_queue.GetAt(pos)->EndOffset){
			delete reqblock;
			return;
		}
	}
	m_BlockRequests_queue.AddTail(reqblock);

	EMULE_CATCH
}

void CUpDownClient::SetUpStartTime(uint32 dwTime){
	EMULE_TRY
	if (dwTime)
		m_dwUploadTime = dwTime;
	else
		m_dwUploadTime = ::GetTickCount();
	EMULE_CATCH
}

void CUpDownClient::SetWaitStartTime(uint32 dwTime){
	EMULE_TRY
	if (dwTime)
		m_dwWaitTime = dwTime;
	else
		m_dwWaitTime = ::GetTickCount();
	EMULE_CATCH
}

uint32 CUpDownClient::SendBlockData(uint32 nMaxAmmount){
	EMULE_TRY
	// START - enkeyDEV(Ottavio84) -Accurate speed measurement-
	TransferredData newitem = {dataratems, GetTickCount()};
	m_AvarageUDR_list.AddTail(newitem);
	sumavgudr += dataratems;
	if (m_AvarageUDR_list.GetCount() > 200)
		sumavgudr -= m_AvarageUDR_list.RemoveHead().datalen;

	float deltat = (float)(m_AvarageUDR_list.GetTail().timestamp - m_AvarageUDR_list.GetHead().timestamp) / 1000.0;
	if (deltat > 0.0) 
        m_nUpDatarate = (uint32)((float)sumavgudr / deltat);
	else
		m_nUpDatarate = 0;
	// END - enkeyDEV(Ottavio84) -Accurate speed measurement-

	m_cSendblock++;
	if (m_cSendblock == 30){
		m_cSendblock = 0;
		theApp.emuledlg->transferwnd.uploadlistctrl.RefreshClient(this);
	}
	dataratems = 0;
	if (socket && !socket->IsBusy()){
		
		if (m_BlockSend_queue.IsEmpty()){
			if (!CreateNextBlockPackage())
				return 0;
		}
        // obaldin: applied enhancements by Maella
        // Splitting packets if necessary
        // Remark: - don't use 2*MAXFRAGSIZE (see CEMSocket::Send()), otherwise the 
        //           counter m_nMaxSendAllowed will trigged the sending of two TCP packets
        //           of 1300 (2*1300) at the same time => increase the ping of the application.
        //         - should be moved to CreateNextBlockPackage()
		if (m_BlockSend_queue.GetHead()->GetRealPacketSize() > 0/*m_nMaxSendAllowed*3*/
			&& m_BlockSend_queue.GetHead()->GetRealPacketSize() > MAXFRAGSIZE*2){
			// splitting packets
				uint32 nSize = m_BlockSend_queue.GetHead()->GetRealPacketSize();
				const char* pBuffer = m_BlockSend_queue.GetHead()->DetachPacket();
				delete m_BlockSend_queue.RemoveHead();
				
				uint32 nPos = nSize;
				bool bLast = true;
				while (nPos){
					uint32 nNewSize = (nPos < MAXFRAGSIZE) ? nPos : MAXFRAGSIZE;
					nPos -= nNewSize;
					char* pBuffer2 = new char[nNewSize];
					memcpy(pBuffer2,pBuffer+nPos,nNewSize);
					m_BlockSend_queue.AddHead(new Packet(pBuffer2,nNewSize,bLast));
					bLast = false;
				}
				delete[] pBuffer;
		}
		m_nMaxSendAllowed += nMaxAmmount;
		while (!socket->IsBusy() && !m_BlockSend_queue.IsEmpty()
			&& m_BlockSend_queue.GetHead()->GetRealPacketSize() <= m_nMaxSendAllowed){
			
			Packet* tosend = m_BlockSend_queue.RemoveHead();
			uint32 nBlockSize = tosend->GetRealPacketSize();
			m_nMaxSendAllowed -= nBlockSize;
//			theApp.uploadqueue->AddUpDataOverheadOther(0, 24);
            dataratems += nBlockSize;
			socket->SendPacket(tosend,true,false);
			if (m_BlockSend_queue.IsEmpty())
				CreateNextBlockPackage();
		}
        // Update credits
        m_nTransferedUp += dataratems;
        theApp.UpdateSentBytes(dataratems);
        credits->AddUploaded(dataratems);

        // Return the real size of sent packet(s) => true bandwidth (it means less wrong here)
        return dataratems;
	}
	EMULE_CATCH
	return 0;
}

void CUpDownClient::FlushSendBlocks(){ // call this when you stop upload, or the socket might be not able to send
	EMULE_TRY
	bool bBreak = false;
	while (!m_BlockSend_queue.IsEmpty() && m_BlockSend_queue.GetHead()->IsSplitted() && socket && socket->IsConnected() && !bBreak ){	
		Packet* tosend = m_BlockSend_queue.RemoveHead();
		bool bBreak = tosend->IsLastSplitted();
		theApp.uploadqueue->AddUpDataOverheadOther(tosend->size);
		socket->SendPacket(tosend,true,false);
	}
	EMULE_CATCH
}

void CUpDownClient::SendHashsetPacket(char* forfileid){
	EMULE_TRY
	CKnownFile* file = theApp.sharedfiles->GetFileByID((uchar*)forfileid);
	if (!file)
		throw GetResString(IDS_ERR_REQ_FNF)+CString(" (SendHashsetPacket)");

	CMemFile* data = new CMemFile();
	data->Write(file->GetFileHash(),16);
	uint16 parts = file->GetHashCount();
	data->Write(&parts,2);
	for (int i = 0; i != parts; i++)
		data->Write(file->GetPartHash(i),16);
	Packet* packet = new Packet(data);
	packet->opcode = OP_HASHSETANSWER;
	delete data;
	theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
	socket->SendPacket(packet,true,true);
	EMULE_CATCH
}

float CUpDownClient::GetClientSpeed()
{
	// Calculates the session speed of the client
	// Providing the other Clients with this info
	// gives then the possibility to select the 
	// sources more intelligently
	if (theApp.stat_transferStarttime==0) return 0;

	DWORD running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
	if (running<5) return 0;

	return (float)(theApp.stat_sessionSentBytes/1024) / running;
}

void CUpDownClient::ClearUploadBlockRequests(){
	EMULE_TRY
	FlushSendBlocks();
	for (POSITION pos = m_BlockRequests_queue.GetHeadPosition();pos != 0;m_BlockRequests_queue.GetNext(pos))
		delete m_BlockRequests_queue.GetAt(pos);
	m_BlockRequests_queue.RemoveAll();
	
	for (POSITION pos = m_DoneBlocks_list.GetHeadPosition();pos != 0;m_DoneBlocks_list.GetNext(pos))
		delete m_DoneBlocks_list.GetAt(pos);
	m_DoneBlocks_list.RemoveAll();
	
	for (POSITION pos = m_BlockSend_queue.GetHeadPosition();pos != 0;m_BlockSend_queue.GetNext(pos))
		delete m_BlockSend_queue.GetAt(pos);
	m_BlockSend_queue.RemoveAll();
	EMULE_CATCH
}

void CUpDownClient::SendRankingInfo(){
	EMULE_TRY
	if (!ExtProtocolAvailable())
		return;
	uint16 nRank = theApp.uploadqueue->GetWaitingPosition(this);
    // By Maverick
#ifndef DISABLE_EXTENDED_INFO_EXCHANGE
    #define DISABLE_EXTENDED_INFO_EXCHANGE
    // The extended info exchange is currently disabled since it is possible
    // to ask the client with several userhashes for the file and then use 
    // the one with the best UL/DL ratio
    // It is planned to reactivate this feature, but with a protection against
    // this userhash spoofing.
    // At the last stage this faeture should make it possible to choose the 
    // sources more intelligently by taking UL/DL ratio, queuerank and 
    // speed of the other client into account.
#endif

#ifdef DISABLE_EXTENDED_INFO_EXCHANGE
	if (!nRank)
		return;
#else
	uint16 nBaseModifier = (uint16) GetScore(false,false,true); //16-Bits are enough for base value
	uint32 nScore = GetScore(false,false,false);

	char *copy1, *copy2;
	copy1 = _strupr( _strdup( m_pszUsername ) );
	copy2 = _strupr( _strdup( theApp.glob_prefs->CommunityString() ) );
	uint8 nCommunity = -1;
	if (!theApp.glob_prefs->CommunityEnabled()) nCommunity = 2;
	else if ((copy1 && copy2) && (strstr(copy1 ,copy2) != NULL )) nCommunity = 1;
	free(copy1);
	free(copy2);

	float fBaseValue = 1.0;
	if(credits != (CClientCredits*)NULL) { 
		fBaseValue *= credits->GetScoreRatio();
	} 
	fBaseValue *= 10;
	uint16 nRatio = (uint16)fBaseValue; 
#endif
	uint16 nClientSpeed = (uint16)((GetClientSpeed() < 65535) ? GetClientSpeed() : 65535); 
										// Providing the other clients with this info 
										// can not be used to leech

	Packet* packet = new Packet(OP_QUEUERANKING,12,OP_EMULEPROT);
	memset(packet->pBuffer,0,12);
	memcpy(packet->pBuffer+0,&nRank,2);
#ifndef DISABLE_EXTENDED_INFO_EXCHANGE
	memcpy(packet->pBuffer+2,&nBaseModifier,1);		// UINT8 is enough 0-100
	memcpy(packet->pBuffer+3,&nRatio,2);			// UINT16 needed saw about 32000 max (SF * UL/DL * RF) 
	memcpy(packet->pBuffer+5,&nScore,4);			// UINT32 needed
	memcpy(packet->pBuffer+9,&nCommunity,1);		// 2-Bits needed
#endif
	memcpy(packet->pBuffer+10,&nClientSpeed,2);		// UINT16 (I think not many have more than 65 MByte UL)
	// END Maverick
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	socket->SendPacket(packet,true,true);
	EMULE_CATCH
}

void CUpDownClient::SendCommentInfo(CKnownFile *file) {
	EMULE_TRY
	if (!m_bCommentDirty || file == NULL || !ExtProtocolAvailable() || m_byAcceptCommentVer < 1)
		return;
	m_bCommentDirty = false;

	int8 rating=file->GetFileRate();
	CString desc=file->GetFileComment();
	if(file->GetFileRate() == 0 && desc.IsEmpty())
		return;

	CMemFile *data = new CMemFile();
	data->Write(&rating,sizeof(rating));
	int length=desc.GetLength();
	if (length>128) length=128;
	data->Write(&length,sizeof(length));
	if (length>0) data->Write(desc.GetBuffer(),length);
	Packet *packet = new Packet(data,OP_EMULEPROT);
	packet->opcode = OP_FILEDESC;
	delete data;
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	socket->SendPacket(packet,true);
	EMULE_CATCH
}

void  CUpDownClient::AddRequestCount(uchar* fileid){
	EMULE_TRY
	for (POSITION pos = m_RequestedFiles_list.GetHeadPosition();pos != 0;m_RequestedFiles_list.GetNext(pos)){
		Requested_File_Struct* cur_struct = m_RequestedFiles_list.GetAt(pos);
		if (!memcmp(cur_struct->fileid,fileid,16)){
			if (::GetTickCount() - cur_struct->lastasked < MIN_REQUESTTIME){
				if (GetDownloadState() != DS_DOWNLOADING)
					cur_struct->badrequests++;
				if (cur_struct->badrequests == BADCLIENTBAN){
					Ban();
				}
			}
			else{
				if (cur_struct->badrequests)
					cur_struct->badrequests--;
			}
			cur_struct->lastasked = ::GetTickCount();
			return;
		}
	}
	Requested_File_Struct* new_struct = new Requested_File_Struct;
	memset(new_struct,0,sizeof(Requested_File_Struct));
	memcpy(new_struct->fileid,fileid,16);
	new_struct->lastasked = ::GetTickCount();
	m_RequestedFiles_list.AddHead(new_struct);
	EMULE_CATCH
}

void  CUpDownClient::UnBan(){
	EMULE_TRY
	m_bBanned = false;
	m_dwBanTime = 0;
	SetWaitStartTime();
	theApp.uploadqueue->UpdateBanCount();
	theApp.emuledlg->transferwnd.UpdateUploadHeader();
	for (POSITION pos = m_RequestedFiles_list.GetHeadPosition();pos != 0;m_RequestedFiles_list.GetNext(pos)){
		Requested_File_Struct* cur_struct = m_RequestedFiles_list.GetAt(pos);
		cur_struct->badrequests = 0;
		cur_struct->lastasked = 0;	
	}
//	theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(this, true, true);
	EMULE_CATCH
}

void CUpDownClient::Ban(){
	EMULE_TRY
	if(theApp.glob_prefs->CommunityNoBanEnabled() && theApp.glob_prefs->CommunityEnabled() && IsCommunity())
		return;
	m_bBanned = true;
	theApp.uploadqueue->UpdateBanCount();
	theApp.emuledlg->transferwnd.UpdateUploadHeader();
	m_dwBanTime = ::GetTickCount();
	theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(this);
	theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_CLIENTBLOCKED),GetUserName());

	EMULE_CATCH
}

void CUpDownClient::UDPFileReasked(){
	EMULE_TRY
	AddAskedCount();
	SetLastUpRequest();
	uint16 nRank = theApp.uploadqueue->GetWaitingPosition(this);
	Packet* response = new Packet(OP_REASKACK,2,OP_EMULEPROT);
	memcpy(response->pBuffer,&nRank,2);

	// By Maverick
	ProxySettings proxy = theApp.glob_prefs->GetProxy();
	if (!proxy.UseProxy){
	    theApp.uploadqueue->AddUpDataOverheadFileRequest(response->size);
            theApp.clientudp->SendPacket(response,GetIP(),GetUDPPort());
        }
	EMULE_CATCH
}

// Lord KiRon
CString CUpDownClient::GetDownloadStateAsString(void) 
{ 
	return GetStatusDLQueueString((eDLQState)GetDownloadState());
} 
// Lord KiRon - end
// By Maverick
uint32	CUpDownClient::GetRemoteScore()
{
	EMULE_TRY
	if (IsRemoteInfoAvaiable()) return m_RemoteScore;
	EMULE_CATCH
	return 0;	// We do not know for how long we are on the queue
				// Furhtermore the we do not know the remote ratio.
}

uint16	CUpDownClient::GetRemoteRatio()
{
	EMULE_TRY
	if (IsRemoteInfoAvaiable()) return m_RemoteRatio;
	// This calculation is not very accurate for several reasons:
	// - We do not know the file priority
	// - We do not save the client info if he has nothing uploaded to us
	// - Other factores like community etc

	// Myself Bot user?
	bool bIsBotuser;	//we still assume that the other client 'punishes' us if our name is 'wrong'
	CString pszUsername = theApp.glob_prefs->GetUserNick();
	if (pszUsername)
		bIsBotuser = (strstr(pszUsername, "edk-files") || strstr(pszUsername, "finder")) && strstr(pszUsername, "com");
	else bIsBotuser = false;

	// Community Sharing
	char *copy1, *copy2;
	copy1 = _strupr( _strdup( m_pszUsername ) );
	copy2 = _strupr( _strdup( theApp.glob_prefs->CommunityString() ) );
	bool iscommunity;
	if (copy1 && copy2)
		iscommunity = (strstr(copy1 ,copy2) != NULL );
	else iscommunity = false;
	free(copy1);
	free(copy2);

	float fBaseValue = 100.0f;
	if (bIsBotuser) fBaseValue *= 0.9f;
	if (theApp.serverconnect->IsLowID()) fBaseValue *= 0.8f;
	if (GetDownloadState() == DS_DOWNLOADING) fBaseValue *= 1.5f;
	if (IsFriend()) fBaseValue *= 2.0f;
	if (theApp.glob_prefs->CommunityEnabled() && iscommunity) fBaseValue *= 2.0f;
	fBaseValue *= GetRemoteBaseModifier();
	fBaseValue *= GetSmallFilePushRatio() ;
	fBaseValue *= GetRareFilePushRatio() ;
	return (uint32)fBaseValue;
	EMULE_CATCH
	return 100;
}

float	CUpDownClient::GetRemoteBaseModifier()
{
	EMULE_TRY
	if (IsRemoteInfoAvaiable()) return (float)m_RemoteBaseModifier / 100.0;
	// This calculation is not very accurate for some reasons:
	// - Crashes can cause that either client can not write
	//   its client data. This can cause differences of the
	//   client data at the two clients.
	if(credits != NULL)
		return credits->GetScoreRatio(true);
	EMULE_CATCH
	return 1.0;
}
