//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "uploadqueue.h"
#include "packets.h"
#include "emule.h"
#include "knownfile.h"
#include "listensocket.h"
#include "ini2.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


static uint32 counter, sec,statsave;
static uint32 igraph, istats;
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
UINT SaveSourcesThread(HANDLE lpArg);

//TODO rewrite the whole networkcode, use overlapped sockets

CUploadQueue::CUploadQueue(CPreferences* in_prefs)
{
	EMULE_TRY

	app_prefs = in_prefs;
	h_timer = SetTimer(0,141,100,TimerProc);
	if (!h_timer)
		theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_ERR_TIMERCREATEFAILED));
	estadatarate = 2000;
	datarate = 0;
	dataratems = 0;
	datarateave = 0;
	bannedcount = 0;
	counter=0;
	sumavgdata = 0;				// enkeyDEV(Ottavio84) -Accurate speed measurement-
	sendtimestamp = GetTickCount();	// enkeyDEV(Ottavio84) -Upload rate is made independent from the inaccurate WM_TIMER-
	bDataRateMaxed = false; 		// Tarod [LoneStar]
	lasttimechecked = GetTickCount() ;
	successfullupcount = 0;
	failedupcount = 0;
	totaluploadtime = 0;
	m_nUpDataRateMSOverhead = 0;
	m_nUpDatarateOverhead = 0;
	m_nUpDataOverheadSourceExchange = 0;
	m_nUpDataOverheadFileRequest = 0;
	m_nUpDataOverheadOther = 0;
	m_nUpDataOverheadServer = 0;
	m_nUpDataOverheadSourceExchangePackets = 0;
	m_nUpDataOverheadFileRequestPackets = 0;
	m_nUpDataOverheadOtherPackets = 0;
	m_nUpDataOverheadServerPackets = 0;
	statsave=0;
	// enkeyDEV(Ottavio84) -Accurate speed measurement-
	TransferredData newitem = {0,GetTickCount()};
	for (int i = 0;i != 400;i++)
		avarage_dr_list.AddHead(newitem);
	// Create timer to save known sources each 30 min 
	m_hSaveSTimer	=	::CreateWaitableTimer(NULL,FALSE,NULL);
	if ( m_hSaveSTimer )
	{
		// Creade lower prioraty thread that will do the "job"
		m_pSaveThread	=	AfxBeginThread(SaveSourcesThread,(LPVOID)m_hSaveSTimer,THREAD_PRIORITY_BELOW_NORMAL);
		if ( ! m_pSaveThread )
		{
			::CloseHandle(m_hSaveSTimer);
			m_hSaveSTimer	=	NULL;
			theApp.emuledlg->AddDebugLogLine(false,_T("Error creating SourcesSaveThread"));
		}
	}
	else
	{
		theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_ERR_TIMERCREATEFAILED));
	}

	EMULE_CATCH2
}

void CUploadQueue::AddUpNextClient(CUpDownClient* directadd)
{
	EMULE_TRY

	POSITION toadd = 0;
	uint32	bestscore = 0;
	CUpDownClient* newclient;
	// select next client or use given client
	if (!directadd){
		POSITION pos1, pos2;
		for (pos1 = waitinglist.GetHeadPosition();( pos2 = pos1 ) != NULL;){
			waitinglist.GetNext(pos1);
			CUpDownClient* cur_client =	waitinglist.GetAt(pos2);
			// clear dead clients
			ASSERT(cur_client->GetLastUpRequest()); 
			if (GetTickCount() - cur_client->GetLastUpRequest() > MAX_PURGEQUEUETIME
					|| !theApp.sharedfiles->GetFileByID(cur_client->reqfileid)) {   // [InterCeptor (remove "?" from queue) 15.11.02]
				RemoveFromWaitingQueue(pos2,true);
				if(!cur_client->socket)
					cur_client->Disconnected();
			}
			// finished clearing
			else if ( (cur_client->GetScore(true) > bestscore) && (!cur_client->IsBanned()) 
				&& (!cur_client->HasLowID() || (cur_client->socket && cur_client->socket->IsConnected()) ) ){
				bestscore = cur_client->GetScore(true);
				toadd = pos2;
			}
		}
		if (!toadd)
			return;
		newclient = waitinglist.GetAt(toadd);
		RemoveFromWaitingQueue(toadd, true);
		theApp.emuledlg->transferwnd.UpdateUploadHeader(); // changed by FoRcHa
	}
	else
		newclient = directadd;

	if (IsDownloading(newclient)){
		return;
	}
	// tell the client that we are now ready to upload
	if (!newclient->socket || !newclient->socket->IsConnected()){
		newclient->SetUploadState(US_CONNECTING);
		newclient->TryToConnect(true);
	}
	else{
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		newclient->socket->SendPacket(packet,true);
		newclient->SetUploadState(US_UPLOADING);
	}
	
/*
	if(ASK_FOR_PARTS_ON_UPLOAD)
		newclient->SendFileRequestForUpload();
*/
	newclient->SetUpStartTime();
	newclient->ResetSessionUp();
	newclient->ResetCompressionGain(); 	// Add show compression
	uploadinglist.AddTail(newclient);
	
	// statistic
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->reqfileid);
	if (reqfile)
		reqfile->statistic.AddAccepted();
	
	theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(newclient);

	EMULE_CATCH
}

void CUploadQueue::Process()
{
	EMULE_TRY

	// START - enkeyDEV(Ottavio84) -Accurate speed measurement-
	sumavgdata -= avarage_dr_list.RemoveHead().datalen;
	TransferredData newitem = {dataratems, ::GetTickCount()};
	avarage_dr_list.AddTail(newitem);
	sumavgdata += dataratems;

	float deltat = (float)(avarage_dr_list.GetTail().timestamp - avarage_dr_list.GetHead().timestamp) / 1000.0;
	if (deltat > 0.0) 
        	datarate = (uint32)((float)sumavgdata / deltat);
	else
		datarate = 0;
	// END - enkeyDEV(Ottavio84) -Accurate speed measurement-
	dataratems = 0;
	if (AcceptNewClient() && waitinglist.GetCount()) {
		AddUpNextClient();
		uLastUploadStart = GetTickCount(); // Added by Tarod [LoneStar]
	}
	if (!uploadinglist.GetCount())
		return;

	int16 clientsrdy = 0;
	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		CUpDownClient* cur_client = uploadinglist.GetAt(pos);
		if ( (cur_client->socket) && (!cur_client->socket->IsBusy()) && cur_client->HasBlocks())
			clientsrdy++;
	}
	if (!clientsrdy){
		estadatarate -= 200;
		bDataRateMaxed = true; // Added by Tarod [LoneStar]
		if (estadatarate < 100)
			estadatarate = 100;
		clientsrdy++;
	}
	else{
		// START - enkeyDEV(Ottavio84) -Upload rate is made independent from the inaccurate WM_TIMER-
		int timediff = GetTickCount() - sendtimestamp;
		sendtimestamp = GetTickCount();
		estadatarate += 200;
		int maxrate = app_prefs->GetMaxUpload() * timediff; // kB/s == B/ms 
		// END - enkeyDEV(Ottavio84) -Upload rate is made independent from the inaccurate WM_TIMER-
		bDataRateMaxed = false; // Added by Tarod [LoneStar]
		if (estadatarate > maxrate)
			estadatarate = maxrate;
	}
	uint32 sendperclient = estadatarate/clientsrdy;
	POSITION pos1,pos2;
	for (pos1 = uploadinglist.GetHeadPosition();( pos2 = pos1 ) != NULL; ){
		uploadinglist.GetNext(pos1);
		CUpDownClient* cur_client = uploadinglist.GetAt(pos2);
		dataratems += cur_client->SendBlockData(sendperclient);
	}

	EMULE_CATCH
}
bool CUploadQueue::AcceptNewClient()
{
	EMULE_TRY

	// check if we can allow a new client to start downloading form us
	uint32 uploadCount=uploadinglist.GetCount();	//Cax2 less CPU usage
	if (uploadCount < MIN_UP_CLIENTS_ALLOWED)
		return true;
	else if (uploadCount >= MAX_UP_CLIENTS_ALLOWED)
		return false;
	//now the final check + Tarod's/LoneStar Upload throttle
	if (theApp.glob_prefs->GetMaxUpload() == UNLIMITED)
	{
		if (uploadCount < (datarate/UPLOAD_CLIENT_DATARATE))
			return true;
	}
	else
	{
		uint16 nMaxSlots = MIN_UP_CLIENTS_ALLOWED;      // obaldin: the previous version had a logical flaw
		if (theApp.glob_prefs->GetMaxUpload() > 10){    //          let's see if this one holds water
			nMaxSlots += (uint16)ceil((float)((theApp.glob_prefs->GetMaxUpload() - 10)*1024) / UPLOAD_CLIENT_DATARATE);
		}
		if (uploadCount < (datarate/UPLOAD_CHECK_CLIENT_DR) && uploadCount < nMaxSlots )
			if (bDataRateMaxed) 
			{
				if (GetTickCount() - uLastUploadStart > UPLOAD_CLIENT_THRESHOLD)
					return true;
			}
			else
				return false;
	}

	EMULE_CATCH

	//nope
	return false;
}

CUploadQueue::~CUploadQueue(){
	KillTimer(0,141);
	if ( m_hSaveSTimer )
	{
		m_pSaveThread->SuspendThread();
		__int64         qwDueTime;
		LARGE_INTEGER   liDueTime;
		qwDueTime = -5 * 10000000;         // Copy the relative time into a LARGE_INTEGER.
		liDueTime.LowPart  = (DWORD) ( qwDueTime & 0xFFFFFFFF );
		liDueTime.HighPart = (LONG)  ( qwDueTime >> 32 );
		// re-Set the timer to me inworked each second
		::SetWaitableTimer(m_hSaveSTimer,&liDueTime,1,NULL,NULL,TRUE);
		// Set the thread to Get more CPU to finish fast
		m_pSaveThread->SetThreadPriority(THREAD_PRIORITY_HIGHEST);
		HANDLE hArr[2];
		hArr[0]	=	m_hSaveSTimer;
		hArr[1]	=	m_pSaveThread->m_hThread;
		// Resume the thread
		m_pSaveThread->ResumeThread();
		// Wait until thread finishes 10000 sec - this should be enough
		WaitForMultipleObjects(2,hArr,TRUE,10000000);
	}
}

POSITION CUploadQueue::GetWaitingClient(CUpDownClient* client)
{
	EMULE_TRY

	return waitinglist.Find(client); 

	EMULE_CATCH

	return 0;
}

/*POSITION CUploadQueue::GetWaitingClientByID(CUpDownClient* client)
{
	EMULE_TRY

	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (client->Compare(waitinglist.GetAt(pos)))
			return pos;
	}

	EMULE_CATCH

	return 0;
}*/

CUpDownClient* CUploadQueue::GetWaitingClientByIP(uint32 dwIP)
{
	EMULE_TRY

	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (dwIP == waitinglist.GetAt(pos)->GetIP())
			return waitinglist.GetAt(pos);
	}

	EMULE_CATCH

	return 0;
}

POSITION CUploadQueue::GetDownloadingClient(CUpDownClient* client)
{
	EMULE_TRY

	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		if (client == uploadinglist.GetAt(pos))
			return pos;
	}

	EMULE_CATCH

	return 0;
}

void CUploadQueue::UpdateBanCount()
{
	EMULE_TRY

	int count=0;
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if(cur_client->IsBanned())
			count++;
	}
	SetBanCount(count);

	EMULE_CATCH
}

void CUploadQueue::AddClientToQueue(CUpDownClient* client, bool bIgnoreTimelimit)
{
	EMULE_TRY

	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID()
		&& !theApp.serverconnect->IsLocalServer(client->GetServerIP(),client->GetServerPort())
		&& client->GetDownloadState() == DS_NONE && !client->IsFriend()
		&& GetWaitingUserCount() > 50)
		return;
	client->AddAskedCount();
	client->SetLastUpRequest();
	if (!bIgnoreTimelimit){
		if (client->IsBanned()){
			if (GetTickCount() - client->GetBanTime() > theApp.glob_prefs->BadClientBanTime()){
				client->UnBan();
			}
			else
				return;
		}
		client->AddRequestCount(client->reqfileid);
	}
	// check for double
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if (cur_client == client){	//already on queue
			client->SendRankingInfo();
			theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(client);
			return;			
		}
/* MERGE26
		// changing back, to avoid hack/mldonkey problems
		else if (client->GetIP() == cur_client->GetIP() || !memcmp(cur_client->GetUserHash(),client->GetUserHash(),16) ) {
		//else if ((client->GetIP() == cur_client->GetIP() && client->GetUserPort() == cur_client->GetUserPort())|| !memcmp(cur_client->GetUserHash(),client->GetUserHash(),16)){ // Lord KiRon
*/
		else if ( client->Compare(cur_client) ) {
			// another client with same ip or hash
			theApp.emuledlg->AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );
			RemoveFromWaitingQueue(pos,true);	
			if (!cur_client->socket)
				cur_client->Disconnected();	
			return;
		}
	}
	// done

/*
	if(ASK_FOR_PARTS_ON_UPLOAD)
		client->SendFileRequestForUpload();
*/

	// Add clients server to list.
	if (theApp.glob_prefs->GetAddServersFromConn()){
		in_addr host;
		host.S_un.S_addr = client->GetServerIP();
		CServer* srv = new CServer(client->GetServerPort(), inet_ntoa(host));
		srv->SetListName(srv->GetAddress());
		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(srv, true))
			delete srv;
		/*else
			theApp.emuledlg->AddLogLine(false,"Added new server: %s:%d", srv->GetFullIP(), srv->GetPort());*/
	}

	// statistic values
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->reqfileid);
		if (reqfile)
			reqfile->statistic.AddRequest();
	// TODO find better ways to cap the list
	if ((uint32)waitinglist.GetCount() > (theApp.glob_prefs->GetQueueSize()+bannedcount))
		return;
	if (client->IsDownloading()){
		// he's already downloading and wants probably only another file
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		client->socket->SendPacket(packet,true);
		return;
	}
	if (waitinglist.IsEmpty() && AcceptNewClient())
		AddUpNextClient(client);
	else{
		waitinglist.AddTail(client);
		client->SetUploadState(US_ONUPLOADQUEUE);
		client->SendRankingInfo();
		theApp.emuledlg->transferwnd.queuelistctrl.AddClient(client);
		theApp.emuledlg->transferwnd.UpdateUploadHeader();
	}

	EMULE_CATCH
}

bool CUploadQueue::RemoveFromUploadQueue(CUpDownClient* client, bool updatewindow)
{
	EMULE_TRY

	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		if (client == uploadinglist.GetAt(pos)){
			if (updatewindow)
				theApp.emuledlg->transferwnd.uploadlistctrl.RemoveClient(uploadinglist.GetAt(pos));
			uploadinglist.RemoveAt(pos);
			if( client->GetTransferedUp() ){
				successfullupcount++;
				totaluploadtime += client->GetUpStartTimeDelay()/1000;
			}
			else
				failedupcount++;
			client->SetUploadState(US_NONE);
			client->ClearUploadBlockRequests();
			// Added by Tarod -saves known.met file to avoid loosing it by accident
			theApp.knownfiles->Save();
			return true;
		}
	}

	EMULE_CATCH

	return false;
}

uint32 CUploadQueue::GetAverageUpTime()
{
	if( successfullupcount ){
		return totaluploadtime/successfullupcount;
	}
	return 0;
}

bool CUploadQueue::RemoveFromWaitingQueue(CUpDownClient* client, bool updatewindow)
{
	EMULE_TRY

	POSITION pos = waitinglist.Find(client);
	if (pos){
		RemoveFromWaitingQueue(pos,updatewindow);
		if (updatewindow)
			theApp.emuledlg->transferwnd.UpdateUploadHeader(); // changed by FoRcHa
		return true;
	}

	EMULE_CATCH

	return false;
}

void CUploadQueue::RemoveFromWaitingQueue(POSITION pos, bool updatewindow)
{
	EMULE_TRY

	CUpDownClient* todelete = waitinglist.GetAt(pos);
	waitinglist.RemoveAt(pos);
	if(todelete == NULL)
		return;
	if( todelete->IsBanned() )
		todelete->UnBan();
	if (updatewindow)
		theApp.emuledlg->transferwnd.queuelistctrl.RemoveClient(todelete);
	todelete->SetUploadState(US_NONE);

	EMULE_CATCH
}


bool CUploadQueue::CheckForTimeOver(CUpDownClient* client)
{
	EMULE_TRY

	if (theApp.glob_prefs->TransferFullChunks())
	{
		if( client->GetUpStartTimeDelay() > 3600000 ) // Try to keep the clients from downloading for ever.
			return true;
// For some reason, some clients can continue to download after a chunk size.
// Are they redownloading the same chunk over and over????
		if( client->GetSessionUp() > 10485760 ) 
			return true;
	}
	else
	{
	uint32 score = client->GetScore(true,true); //Maella - Less CPU usage
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (score < waitinglist.GetAt(pos)->GetScore(true,false))
			return true;
	}
        }
	EMULE_CATCH

	return false;
}

void CUploadQueue::DeleteAll()
{
	EMULE_TRY

	waitinglist.RemoveAll();
	uploadinglist.RemoveAll();

	EMULE_CATCH
}

uint16 CUploadQueue::GetWaitingPosition(CUpDownClient* client)
{
	EMULE_TRY

	if (!IsOnUploadQueue(client))
		return 0;
	uint16 rank = 1;
	uint32 myscore = client->GetScore(false);
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (waitinglist.GetAt(pos)->GetScore(false) > myscore)
			rank++;
	}
	return rank;

	EMULE_CATCH

	return 0;
}

void CUploadQueue::CompUpDatarateOverhead()
{
	EMULE_TRY

	m_AvarageUDRO_list.AddTail(m_nUpDataRateMSOverhead);
	if (m_AvarageUDRO_list.GetCount() > 150)
		m_AvarageUDRO_list.RemoveAt(m_AvarageUDRO_list.GetHeadPosition());
	m_nUpDatarateOverhead = 0;
	m_nUpDataRateMSOverhead = 0;
	for (POSITION pos = m_AvarageUDRO_list.GetHeadPosition();pos != 0;m_AvarageUDRO_list.GetNext(pos))
		m_nUpDatarateOverhead += m_AvarageUDRO_list.GetAt(pos);

	if(m_AvarageUDRO_list.GetCount() > 10)
		m_nUpDatarateOverhead = 10*m_nUpDatarateOverhead/m_AvarageUDRO_list.GetCount();
	else
		m_nUpDatarateOverhead = 0;

	EMULE_CATCH
}

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	EMULE_TRY

	// Barry - Don't do anything if the app is shutting down - can cause unhandled exceptions
	if (!theApp.emuledlg->IsRunning())
		return;

	theApp.clientlist->ResetAllValueCaches();
	theApp.uploadqueue->Process();
	theApp.downloadqueue->Process();

	//--- xrmb:statsautosave ---
	//--- it might be not the best idea to do this here :) ---
	//theApp.knownfiles->Process();
	//--- :xrmb ---
	
    theApp.uploadqueue->CompUpDatarateOverhead();
	theApp.downloadqueue->CompDownDatarateOverhead();
	counter++;

	// one second
	if (counter >= 10){
		counter=0;
	        theApp.clientcredits->Process();
		theApp.serverlist->Process();
		theApp.friendlist->Process();
		if( theApp.serverconnect->IsConnecting() && !theApp.serverconnect->IsSingleConnect() )
			theApp.serverconnect->TryAnotherConnectionrequest();

		theApp.emuledlg->statisticswnd.UpdateConnectionsStatus();

		if (theApp.serverconnect->IsConnecting()) theApp.serverconnect->CheckForTimeout();

		// display graphs
		if(theApp.glob_prefs->GetTrafficOMeterInterval()>0) 
		{
			igraph++;

			if (igraph >= (uint32)(theApp.glob_prefs->GetTrafficOMeterInterval()) ) {
				igraph=0;
				theApp.emuledlg->statisticswnd.SetCurrentRate((float)theApp.uploadqueue->GetDatarate()/1024,(float)theApp.downloadqueue->GetDatarate()/1024);
				theApp.emuledlg->ShowTransferRate();
			}
		}
		if (theApp.emuledlg->activewnd == &theApp.emuledlg->statisticswnd && theApp.emuledlg->IsWindowVisible() )  {
			// display stats
			if (theApp.glob_prefs->GetStatsInterval()>0) {
				istats++;

				if (istats >= (uint32)(theApp.glob_prefs->GetStatsInterval()) ) {
					istats=0;
					theApp.emuledlg->ShowStatistics();
				}
			}
		}
		//save rates every second
		theApp.emuledlg->statisticswnd.RecordRate();

		sec++;
		// 5 seconds
		if (sec>=5) {

			#ifdef _DEBUG
				if (!AfxCheckMemory()) AfxDebugBreak();
			#endif

			sec = 0;
			theApp.listensocket->Process();
			theApp.OnlineSig(); // Added By Bouc7 
			theApp.emuledlg->ShowTransferRate();
            if (theApp.emuledlg->activewnd == &theApp.emuledlg->statisticswnd) {
				theApp.emuledlg->ShowStatistics(); 
			}
		}

		if(theApp.glob_prefs->GetShowToolbarSpeedMeter())	// speedmeter needs more updates
			theApp.emuledlg->ShowTransferRate(false);		// FoRcHa

		statsave++;
		if (statsave>=60) 
		{
			statsave=0;
			CString buffer;
			char* fullpath = new char[strlen(theApp.glob_prefs->GetAppDir())+16];
			sprintf(fullpath,"%spreferences.ini",theApp.glob_prefs->GetAppDir());
			CIni ini( fullpath, "eMule" );
			delete[] fullpath;
			fullpath=NULL;

			buffer.Format("%I64Lu",theApp.stat_sessionReceivedBytes+theApp.glob_prefs->GetTotalDownloaded());
			ini.WriteString("TotalDownloadedBytes",buffer ,"Statistics");

			buffer.Format("%I64Lu",theApp.stat_sessionSentBytes+theApp.glob_prefs->GetTotalUploaded());
			ini.WriteString("TotalUploadedBytes",buffer ,"Statistics");
		}
	}

	EMULE_CATCH
}

CUpDownClient* CUploadQueue::GetNextClient(CUpDownClient* lastclient)
{
	EMULE_TRY

	if (waitinglist.IsEmpty())
		return NULL;
	if (!lastclient)
		return waitinglist.GetHead();
	POSITION pos = waitinglist.Find(lastclient);
	if (!pos){
		TRACE("Error: CServerList::GetNextClient");
		return waitinglist.GetHead();
	}
	waitinglist.GetNext(pos);
	if (!pos)
		return NULL;
	else
		return waitinglist.GetAt(pos);

	EMULE_CATCH

	return NULL;
}

void CUploadQueue::FindSourcesForFileById(CTypedPtrList<CPtrList, CUpDownClient*>* srclist, uchar* filehash) 
{
	EMULE_TRY

	POSITION pos;
	
	pos = uploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = uploadinglist.GetNext(pos);
		if(memcmp(potential->reqfileid, filehash, 16) == 0)
			srclist->AddTail(potential);
	}

	pos = waitinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = waitinglist.GetNext(pos);
		if(memcmp(potential->reqfileid, filehash, 16) == 0)
			srclist->AddTail(potential);
	}

	EMULE_CATCH
}


UINT SaveSourcesThread(HANDLE lpArg)
{
	HANDLE hTimer;
	hTimer	=	lpArg;
	if ( !hTimer )
	{
		return -1;
	}
    __int64         qwDueTime;
     LARGE_INTEGER   liDueTime;
    qwDueTime = -5 * 10000000;         // Copy the relative time into a LARGE_INTEGER.
    liDueTime.LowPart  = (DWORD) ( qwDueTime & 0xFFFFFFFF );
    liDueTime.HighPart = (LONG)  ( qwDueTime >> 32 );
	// Set timer to signal each 30 min 
	::SetWaitableTimer(hTimer,&liDueTime,30*60*1000,NULL,NULL,TRUE);
	bool bExit = false;
	while (!bExit )
	{
		// Wait for timer signal 
		::WaitForSingleObject(hTimer,INFINITE);
		// If eMule supposed to exit
		if ( !theApp.emuledlg->IsRunning() )
		{
			// break and finish the thread
			break;
		}
		// process (save) sources each 30 min
		theApp.knownfiles->Process();
	}
	// Close timer also to signal that we finished
	::CloseHandle(hTimer);
	return 0;
}